unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, DBClient, Grids, DBGrids, Spin, ComCtrls,
  ExtCtrls, QuickRpt, QRCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ClientDataSet1: TClientDataSet;
    ClientDataSet1cno: TStringField;
    ClientDataSet1kind: TStringField;
    ClientDataSet2: TClientDataSet;
    ClientDataSet2kind: TStringField;
    ClientDataSet2mename: TStringField;
    ClientDataSet2fmk: TStringField;
    ClientDataSet2price: TIntegerField;
    ClientDataSet2qty: TIntegerField;
    ClientDataSet2subtal: TIntegerField;
    ClientDataSet3: TClientDataSet;
    ClientDataSet3kind: TStringField;
    ClientDataSet3gnam: TStringField;
    ClientDataSet3price: TIntegerField;
    ClientDataSet4: TClientDataSet;
    ClientDataSet4kind: TStringField;
    ClientDataSet4monam: TStringField;
    ClientDataSet4price: TIntegerField;
    ClientDataSet4mhq: TIntegerField;
    Button1: TButton;
    ClientDataSet5: TClientDataSet;
    ClientDataSet5kind: TStringField;
    ClientDataSet5pack: TStringField;
    ClientDataSet5price: TIntegerField;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    DataSource4: TDataSource;
    DataSource5: TDataSource;
    DBGrid1: TDBGrid;
    ComboBox1: TComboBox;
    SpinEdit1: TSpinEdit;
    TabSheet2: TTabSheet;
    QuickRep1: TQuickRep;
    Button2: TButton;
    QRGroup1: TQRGroup;
    QRBand2: TQRBand;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRDBText1: TQRDBText;
    QRSubDetail1: TQRSubDetail;
    QRLabel5: TQRLabel;
    QRLabel6: TQRLabel;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    QRLabel9: TQRLabel;
    QRLabel10: TQRLabel;
    QRLabel11: TQRLabel;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure QRGroup1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure QRSubDetail1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure QRSubDetail1NeedData(Sender: TObject; var MoreData: Boolean);
    procedure QuickRep1StartPage(Sender: TCustomQuickRep);
  private
    { Private declarations }
    NAMCondition : Integer;
    NewPage : Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  I,Kind : Integer;
begin
  Kind := SpinEdit1.Value;
  ClientDataSet1.Close;
  ClientDataSet1.CreateDataSet;
  Randomize;
  for I := 1 to Kind do
    begin
      with ClientDataSet1 do
        begin
          Append;
          FieldByName('cno').AsString := FormatFloat('00000',I);
          FieldByName('kind').AsString := 'Kind' + FormatFloat('00000',I);
          Post;
        end;
    end;
    ClientDataSet2.Close;
    ClientDataSet2.CreateDataSet;
    ClientDataSet3.Close;
    ClientDataSet3.CreateDataSet;
    ClientDataSet4.Close;
    ClientDataSet4.CreateDataSet;
    ClientDataSet5.Close;
    ClientDataSet5.CreateDataSet;
    ClientDataSet1.First;
    while not ClientDataSet1.Eof do
      begin
// ClientDataSet2
        for I := 1 to 10 + Random(10) do
          begin
            with ClientDataSet2 do
              begin
                Append;
                FieldByName('kind').AsString := ClientDataSet1.FieldByName('kind').AsString;
                FieldByName('menam').AsString := 'Menam' + FormatFloat('00000',I);
                FieldByName('fmk').AsString := 'FMK' + FormatFloat('00000',I);
                FieldByName('price').AsInteger := 100 * (Random(10) + 1);
                FieldByName('uqty').AsInteger :=  1 + Random(10);
                FieldByName('subtal').AsInteger := FieldByName('price').AsInteger * FieldByName('uqty').AsInteger;
                Post;
              end;
          end;
// ClientDataSet3
        for I := 1 to 1 + Random(5) do
          begin
            with ClientDataSet3 do
              begin
                Append;
                FieldByName('kind').AsString := ClientDataSet1.FieldByName('kind').AsString;
                FieldByName('gnam').AsString := 'Gnam' + FormatFloat('00000',I);
                FieldByName('price').AsInteger := 1000 * (Random(10) + 1);
                Post;
              end;
          end;
// ClientDataSet4
        for I := 1 to 1 + Random(5) do
          begin
            with ClientDataSet4 do
              begin
                Append;
                FieldByName('kind').AsString := ClientDataSet1.FieldByName('kind').AsString;
                FieldByName('monam').AsString := 'Monam' + FormatFloat('00000',I);
                FieldByName('price').AsInteger := 1000 * (Random(10) + 1);
                FieldByName('mhq').AsInteger := Random(1000);
                Post;
              end;
          end;
// ClientDataSet5
        for I := 1 to 1 + Random(5) do
          begin
            with ClientDataSet5 do
              begin
                Append;
                FieldByName('kind').AsString := ClientDataSet1.FieldByName('kind').AsString;
                FieldByName('pack').AsString := 'Pack' + FormatFloat('00000',I);
                FieldByName('price').AsInteger := 50 * (Random(10) + 1);
                Post;
              end;
          end;
        ClientDataSet1.Next;
      end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  DBGrid1.DataSource := TDataSource(FindComponent(TComboBox(Sender).Text));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  QuickRep1.Prepare;
  QuickRep1.Preview;
end;

procedure TForm1.QRGroup1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  NAMCondition := 1;
  ClientDataSet2.First;
  ClientDataSet3.First;
  ClientDataSet4.First;
  ClientDataSet5.First;
end;

procedure TForm1.QRSubDetail1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  if NewPage then
    begin
      QRLabel8.Caption := 'Ʀ';
      QRLabel9.Caption := '';
      QRLabel10.Caption := '';
      QRLabel11.Caption := '';
      case NAMCondition of
        1 : QRLabel5.Caption := 'M㦨';
        2 : QRLabel5.Caption := 'Ҩ㦨';
        3 : QRLabel5.Caption := ']˦';
      else
        QRLabel5.Caption := '';
      end;
      QRLabel6.Caption := '';
      QRLabel7.Caption := '';
      NewPage := False;
    end
  else
    begin
// Left Side ClientDateSet2
      if not ClientDataSet2.Eof then
        begin
          QRLabel8.Caption := ClientDataSet2.FieldByName('menam').AsString;
          QRLabel9.Caption := ClientDataSet2.FieldByName('price').AsString;
          QRLabel10.Caption := ClientDataSet2.FieldByName('uqty').AsString;
          QRLabel11.Caption := ClientDataSet2.FieldByName('subtal').AsString;
          ClientDataSet2.Next;
        end
      else
        begin
          QRLabel8.Caption := '';
          QRLabel9.Caption := '';
          QRLabel10.Caption := '';
          QRLabel11.Caption := '';
        end;
// Right Side ClientDataSet3
      if not ClientDataSet3.Eof then
        begin
          QRLabel5.Caption := ClientDataSet3.FieldByName('gnam').AsString;
          QRLabel6.Caption := ClientDataSet3.FieldByName('price').AsString;
          QRLabel7.Caption := '';
          ClientDataSet3.Next;
        end
      else
// Right Side ClientDataSet4
        if not ClientDataSet4.Eof then
          begin
            if NAMCondition = 1 then
              begin
                QRLabel5.Caption := 'Ҩ㦨';
                QRLabel6.Caption := '';
                QRLabel7.Caption := '';
                NAMCondition := 2;
              end
            else
              begin
                QRLabel5.Caption := ClientDataSet4.FieldByName('monam').AsString;
                QRLabel6.Caption := ClientDataSet4.FieldByName('price').AsString;
                QRLabel7.Caption := ClientDataSet4.FieldByName('mhq').AsString;
                ClientDataSet4.Next;
              end;
          end
        else
// Right Side ClientDataSet5
          if not ClientDataSet5.Eof then
            begin
              if NAMCondition = 2 then
                begin
                  QRLabel5.Caption := ']˦';
                  QRLabel6.Caption := '';
                  QRLabel7.Caption := '';
                  NAMCondition := 3;
                end
              else
                begin
                  QRLabel5.Caption := ClientDataSet5.FieldByName('pack').AsString;
                  QRLabel6.Caption := ClientDataSet5.FieldByName('price').AsString;
                  QRLabel7.Caption := '';
                  ClientDataSet5.Next;
                end;
            end
          else
            begin
              QRLabel5.Caption := '';
              QRLabel6.Caption := '';
              QRLabel7.Caption := '';
              NAMCondition := 4;
            end;
    end;
end;

procedure TForm1.QRSubDetail1NeedData(Sender: TObject;
  var MoreData: Boolean);
begin
  if (ClientDataSet2.Eof) and (ClientDataSet5.Eof) and (NAMCondition = 4) then
    MoreData := False
  Else
    MoreData := True;
end;

procedure TForm1.QuickRep1StartPage(Sender: TCustomQuickRep);
begin
  NewPage := True;
end;

end.
